Cheaptard = LibStub("AceAddon-3.0"):NewAddon("Cheaptard", "AceConsole-3.0", "AceEvent-3.0", "AceTimer-3.0")
local Cheaptard = Cheaptard
local L = LibStub("AceLocale-3.0"):GetLocale("Cheaptard", false)

BINDING_HEADER_CHEAPTARD = "Cheaptard"
BINDING_NAME_EQUIP_WORST_AMMO = L["EQUIP_WORST_AMMO"]
BINDING_NAME_EQUIP_BEST_AMMO = L["EQUIP_BEST_AMMO"]

local defaults = {
      profile = {
              boss = "best",
              duel = "best",
              raid = "worst",
              battleground = "worst",
              arena = "best",
              default = "worst",
      }
}

local switch = { active = false, } -- set = nil, back = 0 }

-- options
local options = {
        type="group",
        name=L["OPTIONS_NAME"],
        desc=L["OPTIONS_DESC"],
        args = {
                bosses = {
						order=1,
                        type="select",
                        name=L["BOSS_NAME"],
                        desc=L["BOSS_DESC"],
                        values={ ["best"]=L["EQUIP_BEST_AMMO"], ["worst"]=L["EQUIP_WORST_AMMO"], ["ignore"]=L["IGNORE"] },
                        get=function() return Cheaptard.db.profile.boss end,
                        set=function(i,v) Cheaptard.db.profile.boss = v end,
                },
                raid = {
                		order=2,
                        type="select",
                        name=L["RAID_NAME"],
                        desc=L["RAID_DESC"],
                        values={ ["best"]=L["EQUIP_BEST_AMMO"], ["worst"]=L["EQUIP_WORST_AMMO"], ["ignore"]=L["IGNORE"] },
                        get=function() return Cheaptard.db.profile.raid end,
                        set=function(i,v) Cheaptard.db.profile.raid = v end,
                },
                battleground = {
                		order=10,
                        type="select",
                        name=L["BATTLEGROUND_NAME"],
                        desc=L["BATTLEGROUND_DESC"],
                        values={ ["best"]=L["EQUIP_BEST_AMMO"], ["worst"]=L["EQUIP_WORST_AMMO"], ["ignore"]=L["IGNORE"] },
                        get=function() return Cheaptard.db.profile.battleground end,
                        set=function(i,v) Cheaptard.db.profile.battleground = v end,
                },
                duel = {
                		order=11,
                        type="select",
                        name=L["DUEL_NAME"],
                        desc=L["DUEL_DESC"],
                        values={ ["best"]=L["EQUIP_BEST_AMMO"], ["worst"]=L["EQUIP_WORST_AMMO"], ["ignore"]=L["IGNORE"] },
                        get=function() return Cheaptard.db.profile.duel end,
                        set=function(i,v) Cheaptard.db.profile.duel = v end,
                },
                arena = {
                		order=12,
                        type="select",
                        name=L["ARENA_NAME"],
                        desc=L["ARENA_DESC"],
                        values={ ["best"]=L["EQUIP_BEST_AMMO"], ["worst"]=L["EQUIP_WORST_AMMO"], ["ignore"]=L["IGNORE"] },
                        get=function() return Cheaptard.db.profile.arena end,
                        set=function(i,v) Cheaptard.db.profile.arena = v end,
                },
                default = {
                		order=20,
                        type="select",
                        name=L["DEFAULT_NAME"],
                        desc=L["DEFAULT_DESC"],
                        values={ ["best"]=L["EQUIP_BEST_AMMO"], ["worst"]=L["EQUIP_WORST_AMMO"], ["ignore"]=L["IGNORE"] },
                        get=function() return Cheaptard.db.profile.default end,
                        set=function(i,v) Cheaptard.db.profile.default = v end,
                },
			}
}

function Cheaptard:OnInitialize()
	self.db = LibStub("AceDB-3.0"):New("CheaptardDB", defaults)

	LibStub("AceConfig-3.0"):RegisterOptionsTable("Cheaptard", 	options)
	self.optionsFrame = LibStub("AceConfigDialog-3.0"):AddToBlizOptions("Cheaptard", "Cheaptard")
	
	LibStub("AceConfig-3.0"):RegisterOptionsTable("Cheaptard-Profiles", LibStub("AceDBOptions-3.0"):GetOptionsTable(self.db))
	self.profilesFrame = LibStub("AceConfigDialog-3.0"):AddToBlizOptions("Cheaptard-Profiles", "Profiles", "Cheaptard")
	
	self:RegisterChatCommand("cheaptard", "Command")
	self:RegisterChatCommand("tard", "Command")
	self:RegisterChatCommand("tardtest", "ZONE_CHANGED")
end

function Cheaptard:Command(input)
	InterfaceOptionsFrame_OpenToCategory("Cheaptard")
end

function Cheaptard:EquipWorstAmmo()
	self:EquipAmmo(false)
end

function Cheaptard:EquipBestAmmo()
	self:EquipAmmo(true)
end

-- Equips best or worst ammo found in bags
function Cheaptard:EquipAmmo(use_best_ammo)
	local bestItemName, bestItemLevel, bestItemLink, bestItemRarity, found
	
	found = false
	
	-- For each bag
	for bag = 1, NUM_BAG_SLOTS do
		local slots = GetContainerNumSlots(bag)
		
--		self:Print("bag "..bag.." has "..slots.." slots")
		
		-- For each slot in bag
		for slot = 1, slots do
			local link = GetContainerItemLink(bag, slot)
			if link then
				
				local itemfamily = GetItemFamily(link)
				
				-- If this item can go into a quiver/ammo pouch, consider it
				-- I should get aquainted with bitlib some time
				if itemfamily == 1 or itemfamily == 2 then

--					self:Print("found "..link)
			
					local itemName, itemLink, itemRarity, itemLevel, itemMinLevel, itemType, itemSubType, itemStackCount, itemEquipLoc, itemTexture = GetItemInfo(link)
--					self:Print("level "..itemLevel..", rarity "..itemRarity..", minLevel "..itemMinLevel..", level "..itemLevel)

					-- If the level of this ammo is higher than current best,
					-- replace current best with it.
					if not found or (use_best_ammo and (itemLevel > bestItemLevel or (itemLevel == bestItemLevel and itemRarity > bestItemRarity))) or (not use_best_ammo and (itemLevel < bestItemLevel or (itemLevel == bestItemLevel and itemRarity < bestItemRarity))) then
					
--						self:Print(link.." will do fine!")

						bestItemLink = link
						bestItemName = itemName
						bestItemLevel = itemLevel
						bestItemRarity = itemRarity
						found = true
					end
					
				end
			end
		end
		
	end
	
	if found then
	
		-- Compare with our current equipped ammo
		local currentlink = GetInventoryItemLink("player",GetInventorySlotInfo("AmmoSlot"))
		if currentlink then
			local itemName, itemLink, itemRarity, itemLevel, itemMinLevel, itemType, itemSubType, itemStackCount, itemEquipLoc, itemTexture = GetItemInfo(currentlink)			
			if (use_best_ammo and (itemLevel < bestItemLevel or (itemLevel == bestItemLevel and itemRarity < bestItemRarity))) or (not use_best_ammo and (itemLevel > bestItemLevel or (itemLevel == bestItemLevel and itemRarity > bestItemRarity))) then
				self:Print("|cff22ff22"..L["EQUIPPING"].." "..bestItemLink)
				EquipItemByName(bestItemName)
			end
		end
	else
		self:Print("|cff22ff22"..L["NOAMMOFOUND"])
	end
	
end

function Cheaptard:ToggleBag()
		local link = GetInventoryItemLink("player", ContainerIDToInventoryID(i))
		if link then
			local subtype = select(7, GetItemInfo(link))
			if subtype == L["Soul Bag"] or subtype == L["Ammo Pouch"] or subtype == L["Quiver"] then
				ToggleBag(i)
			end
		end
	
end

function Cheaptard:OnEnable()
	self:RegisterEvent("PLAYER_REGEN_DISABLED")
	self:RegisterEvent("PLAYER_REGEN_ENABLED")
	self:RegisterEvent("DUEL_REQUESTED")
	self:RegisterEvent("DUEL_INBOUNDS");
	self:RegisterEvent("DUEL_FINISHED")
	self:RegisterEvent("PLAYER_TARGET_CHANGED")
	self:RegisterEvent("ZONE_CHANGED_NEW_AREA")
	switch.active = true
end

function Cheaptard:PLAYER_REGEN_ENABLED()
	self:EquipAmmo(self.db.profile.default)
end

function Cheaptard:PLAYER_REGEN_DISABLED()
	if UnitExists("target") and UnitFactionGroup("target") == UnitFactionGroup("player") and not UnitIsFriend("player","target") then
		self:EquipAmmo(self.db.profile.duel)
	end
end

function EquipAmmo(kind)
	if kind == "best" then
		self:EquipBestAmmo()
	elseif kind == "worst" then
		self:EquipWorstAmmo()
	end
end

function Cheaptard:PLAYER_TARGET_CHANGED()
	if UnitClassification("target") == "boss" or UnitClassification("target") == "worldboss" and not UnitIsDead("target") then
		self:EquipAmmo(self.db.profile.boss)
	end
end

function Cheaptard:ZONE_CHANGED_NEW_AREA()
	local inInstance, instanceType = IsInInstance()
	
	if inInstance then
		
		if instanceType == "pvp" then
			self:EquipAmmo(self.db.profile.battlegrounds)
		elseif instanceType == "arena" then
			self:EquipAmmo(self.db.profile.arena)
		elseif instanceType == "raid" then
			self:EquipAmmo( self.db.profile.raid)
		end
		
	end
end

function Cheaptard:OnDisable()
	switch.active = false
end

function Cheaptard:DUEL_FINISHED()
	self:EquipAmmo(self.db.profile.default)
end

function Cheaptard:DUEL_INBOUNDS()
	self:EquipAmmo(self.db.profile.duel)
end

function Cheaptard:DUEL_REQUESTED()
	self:EquipAmmo(self.db.profile.duel)
end

function Cheaptard:Toggle()
	self.db.enabled = not self.db.enabled
	
	if self.db.enabled then
		self:Print("|cff22ff22"..L["TOGGLE_ENABLED"])
	else
		self:Print("|cffff2222"..L["TOGGLE_DISABLED"])
	end
end